"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const fs_1 = require("fs");
const config_1 = require("hardhat/config");
const helpers_1 = require("./helpers");
const gui = async (hre, deploymentPath) => {
    // const result = await walk(process.cwd() + "/" + deploymentPath);
    const deployedChains = await helpers_1.getDeployedChains(process.cwd() + "/" + deploymentPath);
    for (const chain of deployedChains) {
        const deployedContracts = await helpers_1.getDeployedContracts(chain.path);
        chain.contracts = deployedContracts;
    }
    console.log(deployedChains);
    fs_1.writeFileSync(`${__dirname}/../../ui/src/chains/chains.json`, JSON.stringify(deployedChains));
};
config_1.task("gui", "Open the Hardhat GUI")
    .setDescription("Build an interactive GUI for your contracts")
    .addOptionalParam("port", "The port to use", 3000, config_1.types.int)
    .addOptionalParam("deploymentPath", "The path for the deployment files", "deployments")
    .setAction(async (taskArgs, hre) => {
    console.log("Starting React App");
    const { deploymentPath } = taskArgs;
    await gui(hre, deploymentPath);
    child_process_1.execSync(`cd ${__dirname}/../../ui && npm run start`, {
        env: Object.assign(Object.assign({}, process.env), { PORT: taskArgs.port }),
        stdio: "inherit",
    });
});
exports.default = gui;
//# sourceMappingURL=gui.js.map